﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Umc.Core.Web.HttpCompression
{
	/// <summary>
	/// Umc.Core<br/>
	/// HTTP 압축율 입니다.
	/// </summary>
	public enum HttpCompressionLevel
	{
		/// <summary>
		/// Umc.Core<br/>
		/// 1단계의 압축율로써, 최상의 압축율입니다. CPU 자원을 많이 소모할 수 있습니다.
		/// </summary>
		Highest		= 9,
		/// <summary>
		/// Umc.Core<br/>
		/// 2단계의 압축율로써, 상급의 압축율입니다. CPU 자원을 많이 소모할 수 있습니다.
		/// </summary>
		High		= 7,
		/// <summary>
		/// Umc.Core<br/>
		/// 3단계의 압축율로써, 보통의 압축율입니다. 일반적으로 가장 권장합니다.
		/// </summary>
		Normal		= 5,
		/// <summary>
		/// Umc.Core<br/>
		/// 4단계의 압축율로써, 낮은 압축율을 입니다.
		/// </summary>
		Low			= 3,
		/// <summary>
		/// Umc.Core<br/>
		/// 5단계의 압축율로써, 가장 낮은 압축율입니다. CPU 성능이 좋지 않거나, 많은 동시 접속자일 경우 선택하십시오.
		/// </summary>
		Lowest		= 1
	}
}
