﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Umc.Core.Web.HttpCompression
{
	/// <summary>
	/// Umc.Core<br/>
	/// HttpCompressionFile 구성요소에 지정한 Name 속성이 파일명인지 정규식인지를 구분합니다.
	/// </summary>
	public enum HttpCompressionNameType
	{
		/// <summary>
		/// 현재의 Name 속성은 파일명 입니다.
		/// </summary>
		Filename,
		/// <summary>
		/// HttpCompressionFile 구성요소에 지정한 Name 속성은 경로와 파일명의 Path 표현입니다. ex) /intro/default.aspx
		/// </summary>
		Path,
		/// <summary>
		/// HttpCompressionFile 구성요소에 지정한 Name 속성이 정규식의 표현입니다.
		/// </summary>
		RegexExpression
	}
}
