﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Umc.Core.Web.HttpCompression
{
	/// <summary>
	/// Umc.Core<br/>
	/// HTTP 압축 알고리즘 입니다.
	/// </summary>
	public enum HttpCompressionType
	{
		/// <summary>
		/// 압축을 수행하지 않습니다.
		/// </summary>
		None,
		/// <summary>
		/// Umc.Core<br/>
		/// GZip 압축을 지원합니다.
		/// </summary>
		GZip,
		/// <summary>
		/// Umc.Core<br/>
		/// Deflate 압축을 지원합니다.
		/// </summary>
		Deflate,
		/// <summary>
		/// Umc.Core<br/>
		/// Custom Provider 를 제공합니다. Custom Provider 를 통해 콘텐츠를 고유의 압축 알고리즘을 지정하거나<br/>
		/// SSL 을 사용하지 않는 보안 전송에 사용할 수 있습니다.
		/// </summary>
		Custom
	}
}
