﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.IO;

namespace Umc.Core.Web.HttpCompression
{
	/// <summary>
	/// Umc.Core<br/>
	/// 압축 알고리즘을 정의합니다.
	/// </summary>
	public interface IHttpCompressionAlgorism
	{
		/// <summary>
		/// Umc.Core<br/>
		/// 압축 알고리즘을 구현합니다.
		/// </summary>
		/// <param name="outputStream">출력 스트림입니다.</param>
		/// <param name="level">압축율을 지정합니다.</param>
		/// <returns></returns>
		Stream CompressionAlgorism(Stream outputStream, HttpCompressionLevel level);

		/// <summary>
		/// Umc.Core<br/>
		/// 압축 Stream 의 Content-Encoding 입니다.
		/// </summary>
		string ContentEncoding { get; }
	}
}
