﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;

namespace Umc.Core.Web
{
	/// <summary>
	/// Umc.Core<br/>
	/// Http Utility 클래스 입니다.
	/// </summary>
	public static class HttpUtil
	{
		private static MethodInfo miDecryptString	= typeof(System.Web.UI.Page).GetMethod("DecryptString", BindingFlags.NonPublic | BindingFlags.Static);
		private static MethodInfo miEncryptString	= typeof(System.Web.UI.Page).GetMethod("EncryptString", BindingFlags.NonPublic | BindingFlags.Static);

		/// <summary>
		/// Umc.Core<br/>
		/// <see cref="System.Web.UI.EncryptString"/> 의 내부 정적 메서드로서 publicToken 을 이용하여
		/// 문자열을 암호화 합니다.
		/// </summary>
		/// <param name="value">암호화 하고자 하는 문자열 입니다.</param>
		/// <returns>publicToken 을 이용하여 암호화된 문자열 입니다.</returns>
		public static string EncryptString(string value)
		{
			return miEncryptString.Invoke(null, new object[] { value }).ToString();
		}

		/// <summary>
		/// Umc.Core<br/>
		/// <see cref="System.Web.UI.EncryptString"/> 의 내부 정적 메서드로서 publicToken 을 이용하여
		/// 문자열을 복호화 합니다.
		/// </summary>
		/// <param name="encryptString">복호화하고자 하는 문자열 입니다.</param>
		/// <returns>publicToken 을 이용하여 복호화된 문자열 입니다.</returns>
		public static string DecryptString(string encryptString)
		{
			return miDecryptString.Invoke(null, new object[] { encryptString }).ToString();
		}
	}
}
